//#############################################################################
//
// FILE:   empty_driverlib_main.c
//
//! \addtogroup driver_example_list
//! <h1>Empty Project Example</h1> 
//!
//! This example is an empty project setup for Driverlib development.
//!
//
//#############################################################################
//
//
// $Copyright:
// Copyright (C) 2023 Texas Instruments Incorporated - http://www.ti.com/
//
// Redistribution and use in source and binary forms, with or without 
// modification, are permitted provided that the following conditions 
// are met:
// 
//   Redistributions of source code must retain the above copyright 
//   notice, this list of conditions and the following disclaimer.
// 
//   Redistributions in binary form must reproduce the above copyright
//   notice, this list of conditions and the following disclaimer in the 
//   documentation and/or other materials provided with the   
//   distribution.
// 
//   Neither the name of Texas Instruments Incorporated nor the names of
//   its contributors may be used to endorse or promote products derived
//   from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// $
//#############################################################################

//
// Included Files
//
#include "math.h"
#include "driverlib.h"
#include "device.h"
#include "board.h"
#include "c2000ware_libraries.h"

#include "adc.h"

//
// Main
//
//int16_t ADC_getTemperatureC(uint16_t tempResult, ADC_ReferenceMode refMode,float32_t vref);

float32_t tempResult,refMode,vref,Temp_Sensor_Ambient,Temp_Sensor1,value,Temp_Sensor_coils,Temp_Sensor_Pipes;
float32_t VacSen,resultBase,ppbNumber,ADCRESULT0;
//----------Positive Temp-----------
#define BASEREADINGPOSITIVE 960     //;    //980//800
#define SPANCOUNTPOSITIVE 2744     //2020//1900
#define MAXTEMPPOSITIVE 85
//-----------Negative Temp-------
#define BASEREADINGNEGATIVE 54    //980//800
#define SPANCOUNTNEGATIVE 444     //2020//1900
#define MAXTEMPNEGATIVE 40

#define BASEREADINGCOILS 1520    //980//800
#define SPANCOUNTCOILS 1930     //2020//1900
#define MAXTEMPCOILS 50

//-----------------ADD_02012024---------
#define ADC_RESOLUTION_VALUE                (4096U)
#define LOG_10_E                            (0.434294f)
#define TEMP_T_25_K                         (298.15f)//kevin
//air temperature
#define TEMP_AIR_RES_T_25                   (10000U)//Ohm
#define TEMP_AIR_BETA                       (3950U)
#define TEMP_AIR_RES_GND                    (10000U)//Ohm

//coil temperature
#define TEMP_COIL_RES_T_25                  (10000U)//Ohm
#define TEMP_COIL_BETA                      (3950U)
#define TEMP_COIL_RES_GND                   (10000U)//Ohm


unsigned int uiRowTemp;
//static uint32_t uiSubValue;
unsigned long uiTemp;
float fTempValue;
unsigned int tempnewvalue1;
unsigned int tempnewvalue2;
unsigned int tempnewvalue3;


void initEPWM(void);//new
static float ntc_sensor_get_temp(float res, uint16_t res_25, uint16_t beta);

void main(void)
{
    uint32_t* read_ADC_Value=(uint32_t*)0x00000B40;
    uint32_t* read_ADC_Value2=(uint32_t*)0x00000B41;
    uint32_t* read_ADC_Value3=(uint32_t*)0x00000B42;
    //
    // Initialize device clock and peripherals
    //
    Device_init();

    //
    // Disable pin locks and enable internal pull-ups.
    //
    Device_initGPIO();

    //
    // Initialize PIE and clear PIE registers. Disables CPU interrupts.
    //
    Interrupt_initModule();

    //
    // Initialize the PIE vector table with pointers to the shell Interrupt
    // Service Routines (ISR).
    //
    Interrupt_initVectorTable();

    //
    // PinMux and Peripheral Initialization
    //
    Board_init();

    initEPWM();//new

    //
    // C2000Ware Library initialization
    //
    C2000Ware_libraries_init();

    //
    // Enable Global Interrupt (INTM) and real time interrupt (DBGM)
    //
    EINT;
    ERTM;
    EPWM_enableADCTrigger(EPWM1_BASE, EPWM_SOC_A);//new
    EPWM_setTimeBaseCounterMode(EPWM1_BASE, EPWM_COUNTER_MODE_UP);//new

    while(1)
    {
        tempnewvalue1 = (*read_ADC_Value);
        tempnewvalue2 = (*read_ADC_Value2);
        tempnewvalue3 = (*read_ADC_Value3);
//--------------------------------------Ambient sensor-------------------------------------------------
        fTempValue = (float)(ADC_RESOLUTION_VALUE - tempnewvalue1);
        fTempValue *= (TEMP_AIR_RES_GND / tempnewvalue1);
        Temp_Sensor_Ambient = (float)ntc_sensor_get_temp(fTempValue, TEMP_AIR_RES_T_25, TEMP_AIR_BETA);
//-------------------------------------coil sensor------------------------------------------------------
        fTempValue = (float)(ADC_RESOLUTION_VALUE - tempnewvalue2);
        fTempValue *= (TEMP_COIL_RES_GND / tempnewvalue2);
        Temp_Sensor_coils = (float)ntc_sensor_get_temp(fTempValue, TEMP_COIL_RES_T_25, TEMP_COIL_BETA);
//-------------------------------------Pipe sensor------------------------------------------------------
        fTempValue = (float)(ADC_RESOLUTION_VALUE - tempnewvalue3);
        fTempValue *= (TEMP_COIL_RES_GND / tempnewvalue3);
        Temp_Sensor_Pipes = (float)ntc_sensor_get_temp(fTempValue, TEMP_COIL_RES_T_25, TEMP_COIL_BETA);
        //else((tempnewvalue2 < 15) || (tempnewvalue2 >= 3600))
    }
}

static float ntc_sensor_get_temp(float res, uint16_t res_25, uint16_t beta)
{
    float temp = 1 / (1 / TEMP_T_25_K + (log10((float)res/res_25) / LOG_10_E / beta));
    temp -= 273.15;
    return temp;
}
//
__interrupt void INT_myADCA_1_ISR(void)
{
    ADC_clearInterruptStatus(myADCA_BASE, ADC_INT_NUMBER1);
    if(true==ADC_getInterruptOverflowStatus(myADCA_BASE, ADC_INT_NUMBER1))
    {
        ADC_clearInterruptOverflowStatus(myADCA_BASE, ADC_INT_NUMBER1);
        ADC_clearInterruptStatus(myADCA_BASE, ADC_INT_NUMBER1);
    }
    Interrupt_clearACKGroup(INT_myADCA_1_INTERRUPT_ACK_GROUP);
 }
// End of File

__interrupt void pfcCtrlISR(void)
{
    // Place ISR code here....


    ADC_clearInterruptStatus(PFC_MTRS_BASE, ADC_INT_NUMBER2);
    if(true==ADC_getInterruptOverflowStatus(PFC_MTRS_BASE, ADC_INT_NUMBER2))
    {
        ADC_clearInterruptOverflowStatus(PFC_MTRS_BASE, ADC_INT_NUMBER2);
        ADC_clearInterruptStatus(PFC_MTRS_BASE, ADC_INT_NUMBER2);
    }
    Interrupt_clearACKGroup(INT_PFC_MTRS_2_INTERRUPT_ACK_GROUP);
 }

__interrupt void motor1CtrlISR(void)
{
    // Place ISR code here....


    ADC_clearInterruptStatus(PFC_MTRS_BASE, ADC_INT_NUMBER3);
    if(true==ADC_getInterruptOverflowStatus(PFC_MTRS_BASE, ADC_INT_NUMBER3))
    {
        ADC_clearInterruptOverflowStatus(PFC_MTRS_BASE, ADC_INT_NUMBER3);
        ADC_clearInterruptStatus(PFC_MTRS_BASE, ADC_INT_NUMBER3);
    }
    Interrupt_clearACKGroup(INT_PFC_MTRS_3_INTERRUPT_ACK_GROUP);
 }

__interrupt void motor2CtrlISR(void)
{
    // Place ISR code here....


    ADC_clearInterruptStatus(PFC_MTRS_BASE, ADC_INT_NUMBER4);
    if(true==ADC_getInterruptOverflowStatus(PFC_MTRS_BASE, ADC_INT_NUMBER4))
    {
        ADC_clearInterruptOverflowStatus(PFC_MTRS_BASE, ADC_INT_NUMBER4);
        ADC_clearInterruptStatus(PFC_MTRS_BASE, ADC_INT_NUMBER4);
    }
    Interrupt_clearACKGroup(INT_PFC_MTRS_4_INTERRUPT_ACK_GROUP);
 }
//
//
// initEPWM - Function to configure ePWM1 to generate the SOC.
//
void initEPWM(void)
{
    //
    // Disable SOCA
    //
    EPWM_disableADCTrigger(EPWM1_BASE, EPWM_SOC_A);

    //
    // Configure the SOC to occur on the first up-count event
    //
    EPWM_setADCTriggerSource(EPWM1_BASE, EPWM_SOC_A, EPWM_SOC_TBCTR_U_CMPA);
    EPWM_setADCTriggerEventPrescale(EPWM1_BASE, EPWM_SOC_A, 1);

    //
    // Set the compare A value to 1000 and the period to 1999
    // Assuming ePWM clock is 100MHz, this would give 50kHz sampling
    // 50MHz ePWM clock would give 25kHz sampling, etc.
    // The sample rate can also be modulated by changing the ePWM period
    // directly (ensure that the compare A value is less than the period).
    //
    EPWM_setCounterCompareValue(EPWM1_BASE, EPWM_COUNTER_COMPARE_A, 1000);
    EPWM_setTimeBasePeriod(EPWM1_BASE, 1999);

    //
    // Set the local ePWM module clock divider to /1
    //
    EPWM_setClockPrescaler(EPWM1_BASE,
                           EPWM_CLOCK_DIVIDER_1,
                           EPWM_HSCLOCK_DIVIDER_1);

    //
    // Freeze the counter
    //
    EPWM_setTimeBaseCounterMode(EPWM1_BASE, EPWM_COUNTER_MODE_STOP_FREEZE);
}

